package com.gic.store.service.outer.impl;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.enterprise.error.ErrorCode;
import com.gic.enterprise.response.EnterpriseServiceResponse;
import com.gic.store.dto.StoreWidgetDTO;
import com.gic.store.service.StoreWidgetApiService;
import com.gic.store.service.StoreWidgetService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("storeWidgetApiService")
public class StoreWidgetApiServiceImpl implements StoreWidgetApiService {
    @Autowired
    private StoreWidgetService storeWidgetService;

    @Override
    public ServiceResponse<Integer> saveStoreWidget(StoreWidgetDTO storeWidgetDTO) {
        Integer id = storeWidgetDTO.getStoreWidgetId();
        if(id == null){
            id = this.storeWidgetService.saveStoreWidget(storeWidgetDTO);
        }else {
            this.storeWidgetService.updateStoreWidget(storeWidgetDTO);
        }
        if(id != null && id > 0){
            return ServiceResponse.success(id);
        }
        return EnterpriseServiceResponse.failure(ErrorCode.SYSTEM_ERROR);
    }

    @Override
    public ServiceResponse<Integer> saveAuthStoreWidget(StoreWidgetDTO storeWidgetDTO) {
        Integer id = storeWidgetDTO.getStoreWidgetId();
        if(id == null){
            id = this.storeWidgetService.saveStoreWidget(storeWidgetDTO);
        }else {
            this.storeWidgetService.updateAuthStoreWidget(storeWidgetDTO);
        }
        if(id != null && id > 0){
            return ServiceResponse.success(id);
        }
        return EnterpriseServiceResponse.failure(ErrorCode.SYSTEM_ERROR);
    }

    @Override
    public ServiceResponse<StoreWidgetDTO> getStoreWidget(Integer id) {
        StoreWidgetDTO storeWidgetDTO = this.storeWidgetService.getStoreWidget(id);
        if(storeWidgetDTO != null){
            return ServiceResponse.success(storeWidgetDTO);
        }
        return EnterpriseServiceResponse.failure(ErrorCode.SYSTEM_ERROR);
    }

    @Override
    public ServiceResponse<Integer> updateAuth(StoreWidgetDTO storeWidgetDTO) {
        int i = this.storeWidgetService.updateAuth(storeWidgetDTO);
        if(i > 0){
            return ServiceResponse.success(i);
        }
        return EnterpriseServiceResponse.failure(ErrorCode.SYSTEM_ERROR);
    }
}
